︠f9a39e62-413b-404a-99b7-21dece66ec9a︠
class Coalitions:
    "use binary counting to generate all possible coalitions"
    def __init__(self, participants):
        self.participants = participants # maximale binäre Stellen
        self.bin_v = [] # Vektor Länge max mit Zweierpotenzen
        self.bin = 1
        self.bin_v.append(self.bin)
        
        for x in range(self.participants ):
            self.bin = self.bin*2
            self.bin_v.append(self.bin)
        
    def get_coalition(self, x):
        "returns binary value of x as list"
        self.coalition = []
        for i in range(1, self.participants +1):
            if x - self.bin_v[self.participants -i] >= 0:
                x = x-self.bin_v[self.participants -i]
                self.coalition.append(1)
            else:
                self.coalition.append(0)
        return self.coalition

# Example: alle vierstelligen Binaerzahlen als Liste ausgeben: 
#coal = Coalitions(4) 
#for i in range(2^4):
#    print coal.get_coalition(i)

def w_sum(v,w):
    "v: binary List, w: weights"
    "returns weighted sum, v[i] decides if w[i] is counted"
    if len(v) != len(w):
        print "len(v) != len(w) FAIL"
        return 0
        
    sum = 0
    for i in range(len(v)):
        if v[i] == 1:
            sum = sum + w[i]
    return sum        

def abs_banzhaf_index(w, q, j):
    if j >= len(w):
        print "j >= len(w) FAIL"
        return 0
        
    coal = Coalitions(len(w))
    count = 0
    for i in range(2^len(w)):
        c = coal.get_coalition(i)
        if c[j] == 1:
            pass # this coalition includes member j, so just skip
        else:
            if w_sum(c, w) < q:
                c[j] = 1
                if w_sum(c, w) >= q:
                    count += 1
                    #print c
    return count
︡4b8d035e-bd05-49e9-a868-7c2f597230cd︡︡
︠0caeaddf-4e4b-4ce1-b293-140ffff9a53b︠
w = [10,5,4]
q = 10

for j in range(len(w)):
    abs_banzhaf_index(w,q,j)
︡36ca5e3b-6023-4804-89ff-4c1a8866a9ad︡{"stdout": "4\n0\n0"}︡
︠539d1ac2-7577-42c1-88d3-2fb3352308ca︠
w = [9,6,4]
q = 10

for j in range(len(w)):
    abs_banzhaf_index(w,q,j)
︡950bb7be-a6a6-438a-9dec-20f5b6255fc3︡{"stdout": "2\n2\n2"}︡
︠ce362898-d10a-415a-8a8e-f82bda385918︠
w = [4,4,4,2,2,1]
q = 12

for j in range(len(w)):
    abs_banzhaf_index(w,q,j)
︡676efe87-a4ef-4786-8c89-f7a722f67cb2︡{"stdout": "10\n10\n10\n6\n6\n0"}︡
︠ccbbc686-4e75-4693-a083-fc5c9cbae0ac︠
w = [10,10,10,10,5,5,3,3,2]
q = 41

for j in range(len(w)):
    abs_banzhaf_index(w,q,j)
︡2ee6aa51-22e9-4659-ab63-1572626b6677︡{"stdout": "53\n53\n53\n53\n29\n29\n21\n21\n5"}︡
